package net.ihe.gazelle.goctests.application.specifications;


public enum SpecificationType {

    // TODO: 05/01/2022 There is incoherence with Notification types, to be reviewed, check: src/main/java/net/ihe/gazelle/goc/xmm/OwnedRuleKind.java

    GLOBAL("global"),
    CARDINALITY("cardinality"),
    VOCABULARY("vocabulary"),
    MANDATORY("mandatory"),
    CONTEXT("context"),
    DATATYPE("datatype"),
    FIXEDVAL("fixed value"),
    CLOSED("closed"),
    CHOICE("chocie");
//    CONFORMANCE("conformance"),
//    NULLFLAVOR("nullflavor"),
//    FLEXIBILITY("flexibility"),
//    STRENGTH("strength"),
//    ITEM("item"),
//    FRIENDLY("friendly"),
//    PROPERTY("property"),
//    TEXT("text"),
//    ATTRIBUT("attribut"),
//    OPTIONAL("optional"),
//    INCLUDE("include"),
//    VALUESET("valueset"),
//    ASSERT("assert"),
//    REPORT("report"),
//    LET("let"),
//    CONSTRAINT("constraint");


    private String value;

    private SpecificationType(String value){
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public static final String possibleValues = generatePossibleValues() ;

    public static SpecificationType of(String value){
        for(SpecificationType specificationType : SpecificationType.values()){
            if(specificationType.getValue().equals(value)){
                return specificationType;
            }
        }
        return null;
    }

    private static String generatePossibleValues(){
       StringBuilder result = new StringBuilder("[");
       for(SpecificationType s : SpecificationType.values()){
           result.append(s.value).append(",").append("\n");
       }
       result.append("]");
       return result.toString();
    }

    public static String getPossibleValues(){
        return possibleValues;
    }
}
